Summary: RPM installer/updater
Name: yum
Version: 3.4.3
Release: 2
License: GPLv2+
Group: System Environment/Base
Source0: %{name}-%{version}.tar.gz
URL: http://yum.baseurl.org/
Patch0: %{name}-%{version}-makefile.patch
Patch1: %{name}-%{version}-optpath.patch
Patch2: %{name}-%{version}-etcdir.patch
Patch3: %{name}-%{version}-arch.patch 
Patch5: %{name}-%{version}-AIX-rpm-check_error.patch
Patch6: yum-%{version}-yum-utils.patch
Patch7: yum-%{version}-setopt.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch: noarch
BuildRequires: make, patch
BuildRequires: python >= 2.7.13-1
BuildRequires: intltool >= 0.51.0-1

Requires: python >= 2.7.13-1
Requires: python-iniparse >= 0.4-1
Requires: python-pysqlite >= 2.8.3-1
Requires: python-urlgrabber >= 3.10.1-1
Requires: yum-metadata-parser >= 1.1.4-1
Conflicts: rpm >= 5-0
# Zif is a re-implementation of yum in C, however:
#
# 1. There is no co-operation/etc. with us.
# 2. It touches our private data directly.
#
# ...both of which mean that even if there were _zero_ bugs in zif, we'd
# never be able to change anything after the first user started using it. And
# of course:
#
# 3. Users will never be able to tell that it isn't weird yum bugs, when they
# hit them (and we'll probably never be able to debug them, without becoming
# zif experts).
#
# ...so we have two sane choices: i) Conflict with it. 2) Stop developing yum.
Conflicts: zif
Obsoletes: yum-skip-broken <= 1.1.18
Obsoletes: yum-basearchonly <= 1.1.9
Obsoletes: yum-allow-downgrade < 1.1.20-0
Obsoletes: yum-plugin-allow-downgrade < 1.1.22-0
Obsoletes: yum-plugin-protect-packages < 1.1.27-0
Provides: yum-skip-broken
Provides: yum-basearchonly
Provides: yum-allow-downgrade
Provides: yum-plugin-allow-downgrade
Provides: yum-protect-packages
Provides: yum-plugin-protect-packages

%description
Yum is a utility that can check for and automatically download and
install updated RPM packages. Dependencies are obtained and downloaded 
automatically, prompting the user for permission as necessary.


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH
%patch0 -p1 -b .makefile
%patch1 -p1 -b .optpath
%patch3 -p1 -b .arch
%patch5 -p1 -b .AIX-rpm-check_error
%patch6 -p1 -b .yum-utils
%patch7 -p1 -b .setopt


%build
export PATH=/opt/freeware/bin:$PATH
make


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
export PATH=/opt/freeware/bin:$PATH
make DESTDIR=${RPM_BUILD_ROOT} install

# ghost files
mkdir -p ${RPM_BUILD_ROOT}/var/lib/yum/history
mkdir -p ${RPM_BUILD_ROOT}/var/lib/yum/plugins
mkdir -p ${RPM_BUILD_ROOT}/var/lib/yum/yumdb
touch ${RPM_BUILD_ROOT}/var/lib/yum/uuid

cd ${RPM_BUILD_ROOT}
mkdir -p usr/bin
cd usr/bin
ln -sf ../..%{_bindir}/* .


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%pre
# check if rpm.rte installp rpm is installed.
rpm_is_4=0
rpm_rte_ver=`/usr/bin/lslpp -L | /usr/bin/grep rpm.rte | /usr/bin/awk '{ print $2 }'`
if [[ $rpm_rte_ver == "4."* ]] ; then
    rpm_is_4=1
fi

if [[ $rpm_is_4 -ne 1 ]] ; then
   echo "You don't seem to have rpm-4.X installed, found version $rpm_rte_ver."
   echo "Please install rpm.rte 4.X from ftp://ftp.software.ibm.com/aix/freeSoftware/aixtoolbox/INSTALLP/ppc/"
   exit 1
fi


%post
# create the default IBM AIX Toolbox repository
yum_conf="/opt/freeware/etc/yum/repos.d/aixtoolbox.repo"
cat > ${yum_conf} << EOF
[AIX_Toolbox]
name=AIX generic repository
baseurl=https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc/
#baseurl=ftp://anonymous:anonymous@public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc/
enabled=0
gpgcheck=0

[AIX_Toolbox_noarch]
name=AIX noarch repository
baseurl=https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/noarch/
#baseurl=ftp://anonymous:anonymous@public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/noarch/
enabled=0
gpgcheck=0

EOF

osver=`/usr/bin/oslevel`
aixmajor=`/usr/bin/uname -a | /usr/bin/awk '{ print $4 }'`
aixminor=`/usr/bin/uname -a | /usr/bin/awk '{ print $3 }'`

if [[ ${osver} = "6.1.0.0" ]] ; then
    cat >> ${yum_conf} << EOF
[AIX_Toolbox_61]
name=AIX 6.1 specific repository
baseurl=https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-6.1/
#baseurl=ftp://anonymous:anonymous@public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-6.1/
enabled=0
gpgcheck=0

EOF
elif [[ ${osver} = "7.1.0.0" ]] ; then
    cat >> ${yum_conf} << EOF
[AIX_Toolbox_71]
name=AIX 7.1 specific repository
baseurl=https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-7.1/
#baseurl=ftp://anonymous:anonymous@public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-7.1/
enabled=0
gpgcheck=0

EOF
elif [[ ${osver} = "7.2.0.0" ]] ; then
    cat >> ${yum_conf} << EOF
[AIX_Toolbox_72]
name=AIX 7.2 specific repository
baseurl=https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-7.2/
#baseurl=ftp://anonymous:anonymous@public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-7.2/
enabled=0
gpgcheck=0

EOF
fi

# create my perzl.org repository
yum_conf="/opt/freeware/etc/yum/repos.d/perzl-org.repo"

cat > ${yum_conf} << EOF
[perzl.org]
name=perzl.org_AIX_${aixmajor}.${aixminor}
baseurl=ftp://www.oss4aix.org/compatible/aix${aixmajor}${aixminor}/
# alternatively instead of ftp:// you can also use https://
# baseurl=http://www.oss4aix.org/download/compatible/aix${aixmajor}${aixminor}/
# baseurl=https://www.oss4aix.org/download/compatible/aix${aixmajor}${aixminor}/
enabled=1
gpgcheck=0

EOF


%files
%defattr(-,root,system)
%doc README AUTHORS COPYING TODO INSTALL ChangeLog PLUGINS
%config(noreplace) %{_sysconfdir}/yum/yum.conf
%config(noreplace) %{_sysconfdir}/yum/version-groups.conf
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/protected.d
%dir %{_sysconfdir}/%{name}/repos.d
%dir %{_sysconfdir}/%{name}/vars
%config %{_sysconfdir}/logrotate.d/%{name}
%dir %{_sysconfdir}/bash_completion.d
%{_sysconfdir}/bash_completion.d/*
%{_datadir}/yum-cli
%{_bindir}/*
%{_libdir}/python?.?/site-packages/*
%dir /var/cache/yum
%dir /var/lib/yum
%ghost /var/lib/yum/uuid
%ghost /var/lib/yum/history
%ghost /var/lib/yum/plugins
%ghost /var/lib/yum/yumdb
%{_mandir}/man?/yum.?
%{_mandir}/man?/yum-shell.?
%{_datadir}/locale/*/*/*
/usr/bin/*


%changelog
* Thu Oct 11 2018 Michael Perzl <michael@perzl.org> - 3.4.3-2
- Add changes for yum-utils ps plugin.
- Change rpm.rte version checking so that it works if rpm.rte installed
  is higher 4.9.1.3.

* Thu Feb 02 2017 Michael Perzl <michael@perzl.org> - 3.4.3-1
- first version for AIX V5.1 and higher
